<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>CsvInputArchive.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute</a> &gt; <span class="el_source">CsvInputArchive.java</span></div><h1>CsvInputArchive.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PushbackReader;
import java.io.UnsupportedEncodingException;

/**
 *
 */
class CsvInputArchive implements InputArchive {
    
    private PushbackReader stream;
    
<span class="nc" id="L34">    private class CsvIndex implements Index {</span>
        public boolean done() {
<span class="nc" id="L36">            char c = '\0';</span>
            try {
<span class="nc" id="L38">                c = (char) stream.read();</span>
<span class="nc" id="L39">                stream.unread(c);</span>
<span class="nc" id="L40">            } catch (IOException ex) {</span>
<span class="nc" id="L41">            }</span>
<span class="nc bnc" id="L42" title="All 2 branches missed.">            return (c == '}') ? true : false;</span>
        }
<span class="nc" id="L44">        public void incr() {}</span>
    }
    
    private void throwExceptionOnError(String tag) throws IOException {
<span class="nc" id="L48">        throw new IOException(&quot;Error deserializing &quot;+tag);</span>
    }
    
    private String readField(String tag) throws IOException {
        try {
<span class="nc" id="L53">            StringBuilder buf = new StringBuilder();</span>
            while (true) {
<span class="nc" id="L55">                char c = (char) stream.read();</span>
<span class="nc bnc" id="L56" title="All 3 branches missed.">                switch (c) {</span>
                    case ',':
<span class="nc" id="L58">                        return buf.toString();</span>
                    case '}':
                    case '\n':
                    case '\r':
<span class="nc" id="L62">                        stream.unread(c);</span>
<span class="nc" id="L63">                        return buf.toString();</span>
                    default:
<span class="nc" id="L65">                        buf.append(c);</span>
                }
<span class="nc" id="L67">            }</span>
<span class="nc" id="L68">        } catch (IOException ex) {</span>
<span class="nc" id="L69">            throw new IOException(&quot;Error reading &quot;+tag);</span>
        }
    }
    
    static CsvInputArchive getArchive(InputStream strm)
    throws UnsupportedEncodingException {
<span class="nc" id="L75">        return new CsvInputArchive(strm);</span>
    }
    
    /** Creates a new instance of CsvInputArchive */
    public CsvInputArchive(InputStream in)
<span class="nc" id="L80">    throws UnsupportedEncodingException {</span>
<span class="nc" id="L81">        stream = new PushbackReader(new InputStreamReader(in, &quot;UTF-8&quot;));</span>
<span class="nc" id="L82">    }</span>
    
    public byte readByte(String tag) throws IOException {
<span class="nc" id="L85">        return (byte) readLong(tag);</span>
    }
    
    public boolean readBool(String tag) throws IOException {
<span class="nc" id="L89">        String sval = readField(tag);</span>
<span class="nc bnc" id="L90" title="All 2 branches missed.">        return &quot;T&quot;.equals(sval) ? true : false;</span>
    }
    
    public int readInt(String tag) throws IOException {
<span class="nc" id="L94">        return (int) readLong(tag);</span>
    }
    
    public long readLong(String tag) throws IOException {
<span class="nc" id="L98">        String sval = readField(tag);</span>
        try {
<span class="nc" id="L100">            long lval = Long.parseLong(sval);</span>
<span class="nc" id="L101">            return lval;</span>
<span class="nc" id="L102">        } catch (NumberFormatException ex) {</span>
<span class="nc" id="L103">            throw new IOException(&quot;Error deserializing &quot;+tag);</span>
        }
    }
    
    public float readFloat(String tag) throws IOException {
<span class="nc" id="L108">        return (float) readDouble(tag);</span>
    }
    
    public double readDouble(String tag) throws IOException {
<span class="nc" id="L112">        String sval = readField(tag);</span>
        try {
<span class="nc" id="L114">            double dval = Double.parseDouble(sval);</span>
<span class="nc" id="L115">            return dval;</span>
<span class="nc" id="L116">        } catch (NumberFormatException ex) {</span>
<span class="nc" id="L117">            throw new IOException(&quot;Error deserializing &quot;+tag);</span>
        }
    }
    
    public String readString(String tag) throws IOException {
<span class="nc" id="L122">        String sval = readField(tag);</span>
<span class="nc" id="L123">        return Utils.fromCSVString(sval);</span>
        
    }
    
    public byte[] readBuffer(String tag) throws IOException {
<span class="nc" id="L128">        String sval = readField(tag);</span>
<span class="nc" id="L129">        return Utils.fromCSVBuffer(sval);</span>
    }
    
    public void readRecord(Record r, String tag) throws IOException {
<span class="nc" id="L133">        r.deserialize(this, tag);</span>
<span class="nc" id="L134">    }</span>
    
    public void startRecord(String tag) throws IOException {
<span class="nc bnc" id="L137" title="All 4 branches missed.">        if (tag != null &amp;&amp; !&quot;&quot;.equals(tag)) {</span>
<span class="nc" id="L138">            char c1 = (char) stream.read();</span>
<span class="nc" id="L139">            char c2 = (char) stream.read();</span>
<span class="nc bnc" id="L140" title="All 4 branches missed.">            if (c1 != 's' || c2 != '{') {</span>
<span class="nc" id="L141">                throw new IOException(&quot;Error deserializing &quot;+tag);</span>
            }
        }
<span class="nc" id="L144">    }</span>
    
    public void endRecord(String tag) throws IOException {
<span class="nc" id="L147">        char c = (char) stream.read();</span>
<span class="nc bnc" id="L148" title="All 4 branches missed.">        if (tag == null || &quot;&quot;.equals(tag)) {</span>
<span class="nc bnc" id="L149" title="All 4 branches missed.">            if (c != '\n' &amp;&amp; c != '\r') {</span>
<span class="nc" id="L150">                throw new IOException(&quot;Error deserializing record.&quot;);</span>
            } else {
<span class="nc" id="L152">                return;</span>
            }
        }
        
<span class="nc bnc" id="L156" title="All 2 branches missed.">        if (c != '}') {</span>
<span class="nc" id="L157">            throw new IOException(&quot;Error deserializing &quot;+tag);</span>
        }
<span class="nc" id="L159">        c = (char) stream.read();</span>
<span class="nc bnc" id="L160" title="All 2 branches missed.">        if (c != ',') {</span>
<span class="nc" id="L161">            stream.unread(c);</span>
        }
        
<span class="nc" id="L164">        return;</span>
    }
    
    public Index startVector(String tag) throws IOException {
<span class="nc" id="L168">        char c1 = (char) stream.read();</span>
<span class="nc" id="L169">        char c2 = (char) stream.read();</span>
<span class="nc bnc" id="L170" title="All 4 branches missed.">        if (c1 != 'v' || c2 != '{') {</span>
<span class="nc" id="L171">            throw new IOException(&quot;Error deserializing &quot;+tag);</span>
        }
<span class="nc" id="L173">        return new CsvIndex();</span>
    }
    
    public void endVector(String tag) throws IOException {
<span class="nc" id="L177">        char c = (char) stream.read();</span>
<span class="nc bnc" id="L178" title="All 2 branches missed.">        if (c != '}') {</span>
<span class="nc" id="L179">            throw new IOException(&quot;Error deserializing &quot;+tag);</span>
        }
<span class="nc" id="L181">        c = (char) stream.read();</span>
<span class="nc bnc" id="L182" title="All 2 branches missed.">        if (c != ',') {</span>
<span class="nc" id="L183">            stream.unread(c);</span>
        }
<span class="nc" id="L185">        return;</span>
    }
    
    public Index startMap(String tag) throws IOException {
<span class="nc" id="L189">        char c1 = (char) stream.read();</span>
<span class="nc" id="L190">        char c2 = (char) stream.read();</span>
<span class="nc bnc" id="L191" title="All 4 branches missed.">        if (c1 != 'm' || c2 != '{') {</span>
<span class="nc" id="L192">            throw new IOException(&quot;Error deserializing &quot;+tag);</span>
        }
<span class="nc" id="L194">        return new CsvIndex();</span>
    }
    
    public void endMap(String tag) throws IOException {
<span class="nc" id="L198">        char c = (char) stream.read();</span>
<span class="nc bnc" id="L199" title="All 2 branches missed.">        if (c != '}') {</span>
<span class="nc" id="L200">            throw new IOException(&quot;Error deserializing &quot;+tag);</span>
        }
<span class="nc" id="L202">        c = (char) stream.read();</span>
<span class="nc bnc" id="L203" title="All 2 branches missed.">        if (c != ',') {</span>
<span class="nc" id="L204">            stream.unread(c);</span>
        }
<span class="nc" id="L206">        return;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>